import{s as De,n as Le,o as je}from"../chunks/scheduler.c57aa7ef.js";import{S as Ce,i as Me,g as n,s as o,r as x,A as Pe,h as i,f as t,c as a,j as _,u as T,x as y,k as v,y as l,a as s,v as $,d as b,t as k,w}from"../chunks/index.c50cb18e.js";import{D as I}from"../chunks/Docstring.b594fb60.js";import{H as Ee}from"../chunks/Heading.c7d7e0e7.js";function He(_e){let d,B,U,J,D,K,L,ve='PEFT provides several internal utilities for <a href="../developer_guides/model_merging">merging LoRA adapters</a> with the TIES and DARE methods.',N,m,j,me,V,xe="Prune the values of task tensors based on the <code>method</code>.",O,c,C,ce,q,Te="Get the mask of the majority sign across the task tensors. Task tensors are stacked on dimension 0.",Q,p,M,pe,A,ye="Merge the task tensors using disjoint merge.",X,u,P,ue,R,$e="Merge the task tensors using <code>task arithmetic</code>.",Y,g,E,ge,F,be="Merge the task tensors using <code>ties</code>.",Z,h,H,he,z,ke="Merge the task tensors using <code>dare linear</code>.",ee,f,S,fe,G,we="Merge the task tensors using <code>dare ties</code>.",te,W,re;return D=new Ee({props:{title:"Model merge",local:"peft.utils.merge_utils.prune",headingTag:"h1"}}),j=new I({props:{name:"peft.utils.merge_utils.prune",anchor:"peft.utils.merge_utils.prune",parameters:[{name:"tensor",val:": Tensor"},{name:"density",val:": float"},{name:"method",val:": Literal"},{name:"rescale",val:": bool = False"}],parametersDescription:[{anchor:"peft.utils.merge_utils.prune.tensor",description:"<strong>tensor</strong> (<code>torch.Tensor</code>) &#x2014;The tensor to prune.",name:"tensor"},{anchor:"peft.utils.merge_utils.prune.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"},{anchor:"peft.utils.merge_utils.prune.method",description:"<strong>method</strong> (<code>str</code>) &#x2014;The method to use to prune. Should be one of [&#x201C;magnitude&#x201D;, &#x201C;random&#x201D;].",name:"method"},{anchor:"peft.utils.merge_utils.prune.rescale",description:"<strong>rescale</strong> (<code>bool</code>) &#x2014;Whether to rescale the result to preserve the expected value of the original tensor.",name:"rescale"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L75",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The pruned tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),C=new I({props:{name:"peft.utils.merge_utils.calculate_majority_sign_mask",anchor:"peft.utils.merge_utils.calculate_majority_sign_mask",parameters:[{name:"tensor",val:": Tensor"},{name:"method",val:": Literal = 'total'"}],parametersDescription:[{anchor:"peft.utils.merge_utils.calculate_majority_sign_mask.tensor",description:"<strong>tensor</strong> (<code>torch.Tensor</code>) &#x2014;The tensor to get the mask from.",name:"tensor"},{anchor:"peft.utils.merge_utils.calculate_majority_sign_mask.method",description:"<strong>method</strong> (<code>str</code>) &#x2014;The method to use to get the mask. Should be one of [&#x201C;total&#x201D;, &#x201C;frequency&#x201D;].",name:"method"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L103",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The majority sign mask.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),M=new I({props:{name:"peft.utils.merge_utils.disjoint_merge",anchor:"peft.utils.merge_utils.disjoint_merge",parameters:[{name:"task_tensors",val:": Tensor"},{name:"majority_sign_mask",val:": Tensor"}],parametersDescription:[{anchor:"peft.utils.merge_utils.disjoint_merge.task_tensors",description:"<strong>task_tensors</strong> (<code>torch.Tensor</code>) &#x2014;The task tensors to merge.",name:"task_tensors"},{anchor:"peft.utils.merge_utils.disjoint_merge.majority_sign_mask",description:"<strong>majority_sign_mask</strong> (<code>torch.Tensor</code>) &#x2014;The mask of the majority sign across the task tensors.",name:"majority_sign_mask"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L128",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),P=new I({props:{name:"peft.utils.merge_utils.task_arithmetic",anchor:"peft.utils.merge_utils.task_arithmetic",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"}],parametersDescription:[{anchor:"peft.utils.merge_utils.task_arithmetic.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L144",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),E=new I({props:{name:"peft.utils.merge_utils.ties",anchor:"peft.utils.merge_utils.ties",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"},{name:"density",val:": float"},{name:"majority_sign_method",val:": Literal = 'total'"}],parametersDescription:[{anchor:"peft.utils.merge_utils.ties.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"},{anchor:"peft.utils.merge_utils.ties.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"},{anchor:"peft.utils.merge_utils.ties.majority_sign_method",description:`<strong>majority_sign_method</strong> (<code>str</code>) &#x2014;
The method to use to get the majority sign mask. Should be one of [&#x201C;total&#x201D;, &#x201C;frequency&#x201D;].`,name:"majority_sign_method"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L185",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),H=new I({props:{name:"peft.utils.merge_utils.dare_linear",anchor:"peft.utils.merge_utils.dare_linear",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"},{name:"density",val:": float"}],parametersDescription:[{anchor:"peft.utils.merge_utils.dare_linear.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"},{anchor:"peft.utils.merge_utils.dare_linear.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L217",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),S=new I({props:{name:"peft.utils.merge_utils.dare_ties",anchor:"peft.utils.merge_utils.dare_ties",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"},{name:"density",val:": float"},{name:"majority_sign_method",val:": Literal = 'total'"}],parametersDescription:[{anchor:"peft.utils.merge_utils.dare_ties.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"},{anchor:"peft.utils.merge_utils.dare_ties.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"},{anchor:"peft.utils.merge_utils.dare_ties.majority_sign_method",description:`<strong>majority_sign_method</strong> (<code>str</code>) &#x2014;
The method to use to get the majority sign mask. Should be one of [&#x201C;total&#x201D;, &#x201C;frequency&#x201D;].`,name:"majority_sign_method"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/utils/merge_utils.py#L239",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),{c(){d=n("meta"),B=o(),U=n("p"),J=o(),x(D.$$.fragment),K=o(),L=n("p"),L.innerHTML=ve,N=o(),m=n("div"),x(j.$$.fragment),me=o(),V=n("p"),V.innerHTML=xe,O=o(),c=n("div"),x(C.$$.fragment),ce=o(),q=n("p"),q.textContent=Te,Q=o(),p=n("div"),x(M.$$.fragment),pe=o(),A=n("p"),A.textContent=ye,X=o(),u=n("div"),x(P.$$.fragment),ue=o(),R=n("p"),R.innerHTML=$e,Y=o(),g=n("div"),x(E.$$.fragment),ge=o(),F=n("p"),F.innerHTML=be,Z=o(),h=n("div"),x(H.$$.fragment),he=o(),z=n("p"),z.innerHTML=ke,ee=o(),f=n("div"),x(S.$$.fragment),fe=o(),G=n("p"),G.innerHTML=we,te=o(),W=n("p"),this.h()},l(e){const r=Pe("svelte-u9bgzb",document.head);d=i(r,"META",{name:!0,content:!0}),r.forEach(t),B=a(e),U=i(e,"P",{}),_(U).forEach(t),J=a(e),T(D.$$.fragment,e),K=a(e),L=i(e,"P",{"data-svelte-h":!0}),y(L)!=="svelte-bbuf1j"&&(L.innerHTML=ve),N=a(e),m=i(e,"DIV",{class:!0});var se=_(m);T(j.$$.fragment,se),me=a(se),V=i(se,"P",{"data-svelte-h":!0}),y(V)!=="svelte-1y1urne"&&(V.innerHTML=xe),se.forEach(t),O=a(e),c=i(e,"DIV",{class:!0});var ne=_(c);T(C.$$.fragment,ne),ce=a(ne),q=i(ne,"P",{"data-svelte-h":!0}),y(q)!=="svelte-1fmtw9r"&&(q.textContent=Te),ne.forEach(t),Q=a(e),p=i(e,"DIV",{class:!0});var oe=_(p);T(M.$$.fragment,oe),pe=a(oe),A=i(oe,"P",{"data-svelte-h":!0}),y(A)!=="svelte-1yr0ip4"&&(A.textContent=ye),oe.forEach(t),X=a(e),u=i(e,"DIV",{class:!0});var ie=_(u);T(P.$$.fragment,ie),ue=a(ie),R=i(ie,"P",{"data-svelte-h":!0}),y(R)!=="svelte-8ih8a2"&&(R.innerHTML=$e),ie.forEach(t),Y=a(e),g=i(e,"DIV",{class:!0});var ae=_(g);T(E.$$.fragment,ae),ge=a(ae),F=i(ae,"P",{"data-svelte-h":!0}),y(F)!=="svelte-1d45n1k"&&(F.innerHTML=be),ae.forEach(t),Z=a(e),h=i(e,"DIV",{class:!0});var le=_(h);T(H.$$.fragment,le),he=a(le),z=i(le,"P",{"data-svelte-h":!0}),y(z)!=="svelte-1ox69n2"&&(z.innerHTML=ke),le.forEach(t),ee=a(e),f=i(e,"DIV",{class:!0});var de=_(f);T(S.$$.fragment,de),fe=a(de),G=i(de,"P",{"data-svelte-h":!0}),y(G)!=="svelte-xv7fyw"&&(G.innerHTML=we),de.forEach(t),te=a(e),W=i(e,"P",{}),_(W).forEach(t),this.h()},h(){v(d,"name","hf:doc:metadata"),v(d,"content",Se),v(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){l(document.head,d),s(e,B,r),s(e,U,r),s(e,J,r),$(D,e,r),s(e,K,r),s(e,L,r),s(e,N,r),s(e,m,r),$(j,m,null),l(m,me),l(m,V),s(e,O,r),s(e,c,r),$(C,c,null),l(c,ce),l(c,q),s(e,Q,r),s(e,p,r),$(M,p,null),l(p,pe),l(p,A),s(e,X,r),s(e,u,r),$(P,u,null),l(u,ue),l(u,R),s(e,Y,r),s(e,g,r),$(E,g,null),l(g,ge),l(g,F),s(e,Z,r),s(e,h,r),$(H,h,null),l(h,he),l(h,z),s(e,ee,r),s(e,f,r),$(S,f,null),l(f,fe),l(f,G),s(e,te,r),s(e,W,r),re=!0},p:Le,i(e){re||(b(D.$$.fragment,e),b(j.$$.fragment,e),b(C.$$.fragment,e),b(M.$$.fragment,e),b(P.$$.fragment,e),b(E.$$.fragment,e),b(H.$$.fragment,e),b(S.$$.fragment,e),re=!0)},o(e){k(D.$$.fragment,e),k(j.$$.fragment,e),k(C.$$.fragment,e),k(M.$$.fragment,e),k(P.$$.fragment,e),k(E.$$.fragment,e),k(H.$$.fragment,e),k(S.$$.fragment,e),re=!1},d(e){e&&(t(B),t(U),t(J),t(K),t(L),t(N),t(m),t(O),t(c),t(Q),t(p),t(X),t(u),t(Y),t(g),t(Z),t(h),t(ee),t(f),t(te),t(W)),t(d),w(D,e),w(j),w(C),w(M),w(P),w(E),w(H),w(S)}}}const Se='{"title":"Model merge","local":"peft.utils.merge_utils.prune","sections":[],"depth":1}';function Ie(_e){return je(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fe extends Ce{constructor(d){super(),Me(this,d,Ie,He,De,{})}}export{Fe as component};
